;     Ŀ
;        Sound Deluxe System 5, a Maple Leaf production               
;        1996-1997                                                    
;           
;        EFX offsets table                                            
;     

; ----<< Effects initialization routines >>----
iETable dw       0                               ; 0 = no effect
        dw       offset i_A ;
        dw       offset i_B ;
        dw       offset i_C ;
        dw       offset i_D ;
        dw       offset i_E ;
        dw       offset i_F ;
        dw       0                               ; Tone portamento, defined elsewhere
        dw       offset i_H ;
        dw       offset i_I ;
        dw       offset i_J2 ;
        dw       offset i_K ;
        dw       0                               ; Tone portamento + Vol Slide, def. elsewhere
        dw       offset i_M ;
        dw       0                               ; N --
        dw       0                               ; Oxy = sample offset, elsewhere
        dw       0                               ; P --
        dw       offset i_Q ;
        dw       offset i_R ;
        dw       offset i_S ;                    ; special - a group of commands
        dw       offset i_T ;
        dw       offset i_U ;
        dw       offset i_V ;
        dw       0                               ; W --
        dw       0                               ; Xxy = amiga 8xy, unused
        dw       offset i_Y ;
        dw       offset i_Z ;

; ----<< Effects routines >>----
ETable  dw       0                               ; 0 = no effect
        dw       0                               ; A=1=speed, elsewhere
        dw       0                               ; B=2=jump, elsewhere
        dw       0                               ; C=3=cancel, elsewhere
        dw       offset c_D ;
        dw       offset c_E ;
        dw       offset c_F ;
        dw       offset c_G ;
        dw       offset c_H ;     not standard !
        dw       offset c_I ;
        dw       offset c_J2 ;   ; changed from v5.1
        dw       offset c_K ;
        dw       offset c_L ;
        dw       offset c_M ;
        dw       0                               ; N -- N/A
        dw       0                               ; O=15=sample offset, done elsewhere
        dw       0                               ; P -- N/A
        dw       offset c_Q ;
        dw       offset c_R ;
        dw       offset c_S ;                    ; special - a group of commands
        dw       0                               ; T=20=bpm tempo, done elsewhere
        dw       offset c_U ;    not standard !
        dw       0                               ; V=22=g.volume, done elsewhere
        dw       0                               ; W -- N/A
        dw       0                               ; Xxy = amiga 8xy, unused
        dw       0
        dw       offset c_Z ;

; --------<< Special effects (initialization) >>----------
iSTable dw       0                               ; set filter (unused)
        dw       0                               ; glissando control (unused)
        dw       offset i_S2 ;                   ; set finetune
        dw       offset i_S3 ;                   ; vibrato waveform 
        dw       offset i_S4 ;                   ; tremolo waveform
        dw       0                               ; ---
        dw       0                               ; ---
        dw       0                               ; ---
        dw       offset i_S8 ;                   ; set panning
        dw       0                               ; ---
        dw       0                               ; stereo on/off (unused)
        dw       offset i_SB ;                   ; loop/startloop
        dw       offset i_SC ;                   ; note cut
        dw       offset i_SD ;                   ; note delay
        dw       offset i_SE ;                   ; pattern delay
        dw       0                               ; ---

STable  dw       0                               ; set filter (unused)
        dw       0                               ; glissando control (unused)
        dw       0                               ; set finetune
        dw       0                               ; vibrato waveform (elsewhere)
        dw       0                               ; tremolo waveform (elsewhere)
        dw       0                               ; ---
        dw       0                               ; ---
        dw       0                               ; ---
        dw       0                               ; set panning
        dw       0                               ; ---
        dw       0                               ; stereo on/off (unused)
        dw       0                               ; loop/startloop
        dw       offset c_SC ;                   ; note cut
        dw       offset c_SD ;                   ; note delay
        dw       offset c_SE ;                   ; pattern delay
        dw       0                               ; ---

;-----------<<< SDS special commands (init) >>>-------------
iZTable dw       offset i_Z0 ;                   ; surround mode
        dw       offset i_Z1 ;                   ; increment semaphore
        dw       offset i_Z2 ;                   ; fast tremor
        dw       0                               ; ---
        dw       offset i_Z4 ;                   ; skip the next x ticks
        dw       0                               ; ---
        dw       0                               ; ---
        dw       0                               ; ---
        dw       0                               ; ---
        dw       0                               ; ---
        dw       0                               ; ---
        dw       offset i_ZB ;                   ; BPM changes (on/off)
        dw       offset i_ZC ;                   ; Panning changes (on/off)
        dw       0                               ; ---
        dw       0                               ; ---
        dw       0                               ; ---

;-----------<<< SDS special commands >>>-------------
ZTable  dw       0                               ; surround mode
        dw       0                               ; increment semaphore
        dw       offset c_Z2 ;                   ; fast tremor
        dw       0                               ; ---
        dw       offset c_Z4 ;                   ; skip the next x ticks
        dw       0                               ; ---
        dw       0                               ; ---
        dw       0                               ; ---
        dw       0                               ; ---
        dw       0                               ; ---
        dw       0                               ; ---
        dw       0                               ; BPM changes (on/off)
        dw       0                               ; Panning changes (on/off)
        dw       0                               ; ---
        dw       0                               ; ---
        dw       0                               ; ---
